#!/usr/bin/python
# coding: utf-8

import os,sys,shutil
from getexefilever import *
#-----------------------------------------------------------------------------
def DetAppdata(cdir):
    extdir="%s\\%s\\" % (os.getenv("localappdata"),cdir)
    #"Local"
    if not os.path.isdir(extdir):
       extdir="%s\\%s\\" % (os.getenv("appdata"),cdir)
       #"Roaming"
       if not os.path.isdir(extdir):
          return None
    return extdir

#-----------------------------------------------------------------------------
def vstate(fl):
    return "allowed" if fl==0 else "blocked"
#-----------------------------------------------------------------------------
def main(argv):
    if not argv[1:]:
       print "FileTypePolicies Editor (/) 2017-2018 iAN CooG"
       print "-"*78
       print "usage: %s <download_file_types.db>|*|<vivaldi.exe path> [-a/-b/-l ext]" % os.path.basename(argv[0])
       print
       print "download_file_types.pb must exist, use * to find current Vivaldi file in use"
       print "download_file_types.pb CAN be ignored by Vivaldi, specify resource.pak instead"
       print "give vivaldi.exe path to use current version's resource.pak"
       print "give no optional parameter to list all extensions state, else:"
       print "-l ext: lists only ext"
       print "-a ext: allow ext (set flag to 0x00)"
       print "-b ext: block ext (set flag to 0x02)"
       return
    dbname=argv[1]
    if dbname=="*":
       dirname=DetAppdata("Vivaldi\\User Data\\FileTypePolicies")
       if not dirname:
          print "Cannot determine FileTypePolicies, pass a full path for it"
          return
       for root,dirs,files in os.walk(dirname):
           break
       maxd=0
       for d in dirs:
           if int(d)>maxd:
              maxd=int(d)
       dbname="%s%s\\download_file_types.pb" % (dirname,maxd)

    elif "vivaldi.exe" in dbname:
       dirname=dbname.replace("vivaldi.exe","")
       ver=getexefilever(dbname)
       dbname="%s%s\\resources.pak" % (dirname,ver)

    if not os.path.isfile(dbname):
       print "%s does not exist" % dbname
       return

    mode=0
    amodes={"l":1
           ,"a":2
           ,"b":3
           }
    if argv[2:] and argv[3:]:
       if argv[2][0] in "-/":
          if argv[2][1] in amodes:
             mode=amodes[argv[2][1]]
          cext=argv[3]
    h=open(dbname,"rb")
    buff=bytearray(h.read())
    h.close()
    if buff[0]!=0x08:
       if buff[0]!=0x05:
          print "%s not a correct db" % dbname
          return
       else:
          print "Scanning %s for policy data" % dbname
          off=buff.find("\x15\x0A\xD7\x23")
          if off>2:
             off-=2
             if buff[off]==0x08:
                print "ok found @ 0x%08x" % (off)
                startoff=off
                off+=8
                pakmode=True
             else:
                off=0
          else:
             off=0
          if off==0:
             print "not found"
             return
    else:
       startoff=0
       off=8
       pakmode=False

    changed=0
    while True:
       bl=buff[off]
       off+=1
       if buff[off]==0x0a:
          ln=buff[off+1]
          ex=str(buff[off+2:off+2+ln])
          floff=off+bl-3
          fl=buff[floff]
          if (mode==0) or ((mode==1)and(ex==cext)):
             print "%02x==%s %s" % (fl,vstate(fl),ex)
          if ((mode>=2)and(ex==cext)):
             if mode==2:
                if buff[floff]!=0:
                   buff[floff]=0
                   changed=1
                break
             elif mode==3:
                if buff[floff]==0:
                   buff[floff]=2
                   changed=1
                break
          off+=bl+1
       else:
          break
    if mode>=2 and changed==1:
       fl=buff[floff]
       print "%02x->%s %s" % (fl,vstate(fl),ex)
       bak="%s.bak" % dbname
       if not os.path.isfile(bak):
          shutil.copy(dbname,bak)
       h=open(dbname,"r+b")
       h.seek(startoff,0)
       h.write(buff[startoff:floff+1])
       h.close()
    return

#-----------------------------------------------------------------------------
if __name__ == "__main__":
  main(sys.argv)

